---
title: HTMLInputElement.stepUp()
slug: Web/API/HTMLInputElement/stepUp
tags:
  - API
  - HTML DOM
  - HTMLInputElement
  - Method
  - Reference
  - Text Field Selection API
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>HTMLInputElement.stepUp()</code></strong> method increments the value of a numeric type of  {{HTMLElement("input")}} element by the value of the <code><a href="/en-US/docs/Web/HTML/Attributes/step">step</a></code> attribute, or the default <code>step</code> value if the step attribute is not explicitly set. The method, when invoked, increments the {{htmlattrxref("value","input")}} by ({{htmlattrxref("step","input")}} * n), where <code><var>n</var></code> defaults to <code>1</code> if not specified, and <code><a href="/en-US/docs/Web/HTML/Attributes/step">step</a></code> defaults to the default value for <code>step</code> if not specified.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th>Input type</th>
   <th>Default step value</th>
   <th>Example step declaration</th>
  </tr>
  <tr>
   <td>{{HTMLElement("input/date", "date")}}</td>
   <td><code>1</code> (day)</td>
   <td>7 day (one week) increments:<br>
    <code class="brush: html">&lt;input type="date" min="2019-12-25" step="7"&gt;</code></td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/month", "month")}}</td>
   <td><code>1</code> (month)</td>
   <td>12 month (one year) increments:<br>
    <code class="brush: html">&lt;input type="month" min="2019-12" step="12"&gt;</code></td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/week", "week")}}</td>
   <td><code>1</code> (week)</td>
   <td>Two week increments:<br>
    <code class="brush: html">&lt;input type="week" min="2019-W23" step="2"&gt;</code></td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/time", "time")}}</td>
   <td><code>60</code> (seconds)</td>
   <td>900 second (15 minute) increments:<br>
    <code class="brush: html">&lt;input type="time" min="09:00" step="900"&gt;</code></td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/datetime-local", "datetime-local")}}</td>
   <td><code>1</code> (day)</td>
   <td>Same day of the week:<br>
    <code class="brush: html">&lt;input type="datetime-local" min="019-12-25T19:30" step="7"&gt;</code></td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/number", "number")}}</td>
   <td><code>1</code></td>
   <td>0.1 increments<br>
    <code class="brush: html">&lt;input type="number" min="0" step="0.1" max="10"&gt;</code></td>
  </tr>
  <tr>
   <td>{{HTMLElement("input/range", "range")}}</td>
   <td><code>1</code></td>
   <td>Increments by 2:<br>
    <code class="brush: html">&lt;input type="range" min="0" step="2" max="10"&gt;</code></td>
  </tr>
 </thead>
</table>

<p>The method, when invoked, changes the form control's value by the value given in the <code>step</code> attribute, multiplied by the parameter, within the constraints set on the form control. The default value for the parameter, if no value is passed, is <code>1</code>. The method will not cause the value to exceed the set <code><a href="/en-US/docs/Web/HTML/Attributes/max">max</a></code> value, or defy the constraints set by the <code><a href="/en-US/docs/Web/HTML/Attributes/step">step</a></code> attribute.</p>

<p>If the value before invoking the <code>stepUp()</code> method is invalid—for example, if it doesn't match the constraints set by the step attribute—invoking the <code>stepUp()</code> method will return a value that does match the form controls constraints.</p>

<p>If the form control is non time, date, or numeric in nature, and therefore does not support the <code>step</code> attribute (see the list of supported input types in the table above), or if the step value is set to <code>any</code>, an <code>InvalidStateError</code> exception is thrown.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>element</em>.stepUp(<em> [ stepIncrement ] </em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em><code>stepIncrement</code></em></dt>
 <dd>The optional  <code><em>stepIncrement</em></code> paremeter is a numeric value.  If no parameter is passed, <code><em>stepIncrement</em></code> defaults to <code>1</code>.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>Click the button in this example to increment the {{HTMLElement("input/number", "number")}} input type:</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;p&gt;
  &lt;label&gt;Enter a number between 0 and 400 that is divisible by 5:
   &lt;input type="number" step="5" id="theNumber" min="0" max="400"&gt;
  &lt;/label&gt;
&lt;/p&gt;
&lt;p&gt;
  &lt;label&gt;Enter how many values of step you would like to increment by or leave it blank:
   &lt;input type="number" step="1" id="incrementer" min="0" max="25"&gt;
  &lt;/label&gt;
&lt;/p&gt;
&lt;input type="button" value="Increment" id="theButton"&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">/* make the button call the function */
let button = document.getElementById('theButton')
button.addEventListener('click', function() {
  steponup()
})

function steponup() {
  let input = document.getElementById('theNumber')
  let val = document.getElementById('incrementer').value

  if (val) {  /* increment with a parameter */
    input.stepUp(val)
  } else {    /* or without a parameter. Try it with 0 */
    input.stepUp()
  }
}</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css">input:invalid {
  border: red solid 3px;
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example")}}</p>

<p>Note if you don't pass a parameter to the <code>stepUp</code> method, it defaults to <code>1</code>. Any other value is a multiplier of the <code>step</code> attribute value, which in this case is <code>5</code>. If you pass <code>4</code> as the <code><var>stepIncrement</var></code>, the input will <code>stepUp</code> by <code>4 * 5</code>, or <code>20</code>. If the parameter is <code>0</code>, the number will not be incremented. The stepUp will not allow the input to out of range, in this case stopping when it reaches <code>400</code>, and rounding down any floats that are passed as a parameter.</p>

<p>Try setting the step increment to <code>1.2</code>. What happens when you invoke the method?</p>

<p>Try setting the value to <code>4</code>, which is not valid. What happens when you invoke the method?</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("HTML WHATWG", "input.html#dom-input-stepup", "stepUp()")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5.1", "sec-forms.html#dom-htmlinputelement-stepup", "stepUp()")}}</td>
   <td>{{Spec2("HTML5.1")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5 W3C", "sec-forms.html#dom-htmlinputelement-stepup", "stepUp()")}}</td>
   <td>{{Spec2("HTML5 W3C")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.HTMLInputElement.stepUp")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTMLElement("input")}}</li>
 <li>{{domxref("HTMLInputElement")}}</li>
 <li>{{domxref("HTMLInputElement.stepDown")}}</li>
 <li><code><a href="/en-US/docs/Web/HTML/Attributes/step">step</a></code>, <code><a href="/en-US/docs/Web/HTML/Attributes/min">min</a></code> and <code><a href="/en-US/docs/Web/HTML/Attributes/max">max</a></code> attributes</li>
</ul>
